package accrue.analysis.goals;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import polyglot.ast.NodeFactory;
import polyglot.frontend.Job;
import polyglot.frontend.Scheduler;
import polyglot.frontend.goals.Goal;
import polyglot.frontend.goals.VisitorGoal;
import polyglot.visit.MakeNarrowingAssignmentsExplicit;
import accrue.AccrueScheduler;

public class MakeNarrowingAssignmentsExplicitGoal extends VisitorGoal {
    public static Goal create(Scheduler scheduler, Job job, NodeFactory nf) {
        return scheduler.internGoal(new MakeNarrowingAssignmentsExplicitGoal(job,
                                                                             nf));
    }

    protected MakeNarrowingAssignmentsExplicitGoal(Job job, NodeFactory nf) {
        super(job, new MakeNarrowingAssignmentsExplicit(nf));
    }

    @Override
    public Collection<Goal> prerequisiteGoals(Scheduler scheduler) {
        List<Goal> l = new ArrayList<Goal>();
        l.add(scheduler.ReachabilityChecked(job));
        l.add(scheduler.ConstantsChecked(job));
        l.add(scheduler.ExceptionsChecked(job));
        l.add(scheduler.ExitPathsChecked(job));
        l.add(scheduler.InitializationsChecked(job));
        l.add(scheduler.ConstructorCallsChecked(job));
        l.add(scheduler.ForwardReferencesChecked(job));

        l.add(((AccrueScheduler) scheduler).helper().MoveInnerClassesGoal(job));
        l.add(((AccrueScheduler) scheduler).helper().MoveLocalClassesGoal(job));
        return l;
    }
}
